# - Try to find Fftw3
# Once done this will define
#
#  FFTW3_FOUND - system has Fftw3
#  FFTW3_INCLUDE_DIRS - the Fftw3 include directory
#  FFTW3_LIBRARIES - Link these to use Fftw3

# use pkg-config to get the directories and then use these values
# in the FIND_PATH() and FIND_LIBRARY() calls
FIND_PACKAGE(PkgConfig)
PKG_CHECK_MODULES(PC_LIBFFTW fftw3)
SET(LIBFFTW3_DEFINITIONS ${PC_LIBFFTW_CFLAGS_OTHER})

FIND_PATH(FFTW3_INCLUDE_DIRS NAMES fftw3.h
   HINTS
   ${PC_LIBFFTW_INCLUDEDIR}
   ${PC_LIBFFTW_INCLUDE_DIRS}
   PATHS
     $ENV{FFTW_DIR}
   PATH_SUFFIXES 
     include
   )

IF(DEFINED JANUS_REAL_SINGLE OR DEFINED JANUS_FFTW_SINGLE)
  FIND_LIBRARY(FFTW3_LIBRARIES NAMES fftw3f libfftw3f libfftwf-3.3
    HINTS
    ${PC_LIBFFTW_LIBDIR}
    ${PC_LIBFFTW_LIBRARY_DIRS}
    PATHS
    $ENV{FFTW_DIR}
    PATH_SUFFIXES 
    lib
    ) 
ELSE(DEFINED JANUS_REAL_SINGLE OR DEFINED JANUS_FFTW_SINGLE)
  FIND_LIBRARY(FFTW3_LIBRARIES NAMES fftw3 libfftw3 libfftw-3.3
    HINTS
    ${PC_LIBFFTW_LIBDIR}
    ${PC_LIBFFTW_LIBRARY_DIRS}
    PATHS
    $ENV{FFTW_DIR}
    PATH_SUFFIXES 
    lib
    ) 
ENDIF(DEFINED JANUS_REAL_SINGLE OR DEFINED JANUS_FFTW_SINGLE)


# handle the QUIETLY and REQUIRED arguments and set LIBFFTW3_FOUND to TRUE if 
# all listed variables are TRUE
INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(FFTW3 DEFAULT_MSG FFTW3_INCLUDE_DIRS FFTW3_LIBRARIES)

MARK_AS_ADVANCED(FFTW3_INCLUDE_DIRS FFTW3_LIBRARIES)
